##############################################
#               Distance focale              #
##############################################

import numpy as np
import matplotlib.pyplot as plt
from random import random
plt.close('all')

#Données expérimentales [A,O,Ap]
positions=[28.7,39.4,149.7]
Delta=[0.2,1,0.2]

#Initialisation des tableaux de données aléatoires

N=1000000 #Choix du nombre de valeurs aléatoires générées
tabIN=np.zeros([N,len(positions)])#Données expérimentales en entrées
tabOUT=np.zeros(N) #Tableau de valeurs de f' en sortie 

#Génération du tableau de sortie
for i in range(len(tabOUT)):
    for k in range(len(positions)):
        tabIN[i][k]=positions[k]+(1-2*random())*Delta[k]
    tabOUT[i]=1/(1/(tabIN[i][2]-tabIN[i][1])-1/(tabIN[i][0]-tabIN[i][1]))    
  
#Calculs statistiques:
fp=tabOUT.mean()
ufp=tabOUT.std(ddof=1)
print("f'= ",round(fp,2),"cm")
print("avec une incertitude-type de ", round(ufp,2), 'cm')
    
#Tracé de l'histogramme
N=int(np.sqrt(len(tabOUT)))#Nombre de barres
plt.hist(tabOUT, bins=N)
plt.title('Calcul de distance focale par méthode de Monté Carlo')
plt.show()



